; -----------------------------------------------------------------------------
; mod_sharedmem.as - vZXԋLW[
; Version 1.1 [2023.06.24 - 2024.02.28]
; Copyright (c) 2023-2024 Lala Madotuki
; -----------------------------------------------------------------------------
; قȂvZX(exe)ԂŋL(}bvgt@C)ăf[^(ϐ)
; ̋Lł܂BvZX𕪗ʐMꍇɎg܂B
; pE񏤗p킸ARɎvOɑgݍłgp܂B
; vOɑgݍލۂɂ̃W[ςĂ\܂B
; gݍ񂾃\tgEFAł̖{W[҂̒쌠\͔CӂłB
; ̃W[̒쌠\̉E폜͋֎~Ƃ܂B
; -----------------------------------------------------------------------------
; Rsyp
; #include "mod_sharedmem.as"
; -----------------------------------------------------------------------------

#ifndef __MOD_SHAREDMEM__
#define __MOD_SHAREDMEM__

	// W[ϐɃANZX邽߂̃}N
	#define global sharedmem_buf	buf@mod_sharedmem		// obt@(ڎQƂꍇ)
	#define global sharedmem_bufadr	bufadr@mod_sharedmem	// obt@̐擪AhX
	#define global sharedmem_h		hobj@mod_sharedmem		// t@C}bsOIuWFNg̃nh

#module "mod_sharedmem"

	#uselib "kernel32.dll"
	#func CreateFileMapping "CreateFileMappingA" sptr,sptr,sptr,sptr,sptr,sptr
	#func MapViewOfFile "MapViewOfFile" sptr,sptr,sptr,sptr,sptr
	#func UnmapViewOfFile "UnmapViewOfFile" sptr
	#func CloseHandle "CloseHandle" sptr
;	#func GetLastError "GetLastError"

	#define FILE_MAP_WRITE			2
	#define FILE_MAP_READ			4
	#define PAGE_READWRITE			4
;	#define ERROR_ALREADY_EXISTS	183

// t@C}bsOIuWFNg̍쐬
// create_sharedmem "IuWFNg",TCY
#deffunc create_sharedmem str _s1, int _size
	p=_s1	// IuWFNg
	CreateFileMapping -1,0,PAGE_READWRITE,0,_size,varptr(p)
	hobj=stat	// nh
	if hobj=0 { dialog "Failed to create shared memory.",1,"Error": end }
;	if hobj=0 { return 1 }					// ĂяoŔ肷ꍇ
;	GetLastError							// G[R[h擾
;	if stat=ERROR_ALREADY_EXISTS {  }		// ɓIuWFNgꍇ
	MapViewOfFile hobj,FILE_MAP_WRITE,0,0,0	// r[̃}bsO
	bufadr=stat								// 擪AhX
	dupptr buf,bufadr,_size,2				// Lϐ(buf)Ɋ蓖
	return

// () ݂̃W[dlł́ÃIuWFNg𓯎ɍ쐬ł܂B
// gI close_sharedmem ŔjĂč쐬ĂB

// }bsOIuWFNg̔j
#deffunc close_sharedmem
	if hobj {
		UnmapViewOfFile bufadr
	    CloseHandle hobj
	    hobj=0
	    dim buf	// obt@Ă
	}
	return

// 1oCg
#deffunc poke_sharedmem int _p1, int _p2
	poke buf,_p1,_p2
	return

// 2oCg
#deffunc wpoke_sharedmem int _p1, int _p2
	wpoke buf,_p1,_p2
	return

// 4oCg
#deffunc lpoke_sharedmem int _p1, int _p2
	lpoke buf,_p1,_p2
	return

// 1oCgǂݏo
#defcfunc peek_sharedmem int _p1
	return peek(buf,_p1)

// 2oCgǂݏo
#defcfunc wpeek_sharedmem int _p1
	return wpeek(buf,_p1)

// 4oCgǂݏo
#defcfunc lpeek_sharedmem int _p1
	return lpeek(buf,_p1)

// () ̓obt@̐擪gp܂B
// ̗prŎgpĂ镔ɏ㏑Ȃ悤ɐ݌vKv܂B
// ܂A擪1oCgڂ͓̂߂̃tOƂĎgp܂B

// 񏑂()
#deffunc write_sharedmem str _s1
	p=_s1
	memcpy buf,p,strlen(p)+1,1,0
	write_sync
	return

// ǂݏo()
#defcfunc read_sharedmem
	read_sync
	return strmid(buf,1,$1000000)

// ݓ҂
#deffunc write_sync
	poke_sharedmem 0,1
	p=1
	repeat 10000					// ^CAEg10b
		if peek_sharedmem(0)=2 { p=0: break }
		await 1
	loop
	poke_sharedmem 0,0
	if p { close_sharedmem: end }	// ^CAEgȂ狭I
	return

// ǂݏo҂
#deffunc read_sync
	p=1
	repeat 10000					// ^CAEg10b
		if peek_sharedmem(0)=1 { p=0: break }
		await 1
	loop
	poke_sharedmem 0,2
	if p { close_sharedmem: end }	// ^CAEgȂ狭I
	return

/*
// 񏑂(񓯊)
#deffunc write_sharedmem str _s1
	buf=_s1
	return

// ǂݏo(񓯊)
#defcfunc read_sharedmem
	return buf
*/

#global
#endif

